var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/; 
var fixedAllColor='#d3d7e0,#adb9c6,#8d9ead,#738491,#5c6a7e,#415567,#000000,#ffffff,#ff0000,#999999,#bcbcbc,#434343,#3ebee6,#f0f9fc">';
var colorMap=[
	{key:'#d3d7d0',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'},
	{key:'#adb9c6',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'},
	{key:'#8d9ead',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#738491',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#5c6a7e',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#415567',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#000000',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#ffffff',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'},
	{key:'#ff0000',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#999999',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#bcbcbc',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'},
	{key:'#434343',value:'rgb(255, 255, 255)',borderValue:'transparent'},
	{key:'#3ebee6',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'},
	{key:'#f0f9fc',value:'rgb(0, 0, 0)',borderValue:'rgb(204, 204, 204)'}
];
String.prototype.colorRgb = function(){  //十六进制颜色码转换成RGB颜色值
    var sColor = this.toLowerCase();  
    if(sColor && reg.test(sColor)){  
        if(sColor.length === 4){  
            var sColorNew = "#";  
            for(var i=1; i<4; i+=1){  
                sColorNew += sColor.slice(i,i+1).concat(sColor.slice(i,i+1));     
            }  
            sColor = sColorNew;  
        }  
        //处理六位的颜色值  
        var sColorChange = [];  
        for(var i=1; i<7; i+=2){  
            sColorChange.push(parseInt("0x"+sColor.slice(i,i+2)));    
        }  
        return "RGB(" + sColorChange.join(",") + ")";  
    }else{  
        return sColor;    
    }  
};  
function getcolor(colorMap,color,value){//由背景颜色获取对应的字体颜色
	var returncolor=null;
	for(var i=0;i<colorMap.length;i++){
		if(color==colorMap[i].key){
			returncolor=colorMap[i][value];
			break;
		}
	}
	return returncolor
}
function colorPicker(obj,selectedColor,froupIndex){//填充颜色选择框 obj是input
	var defaultIndex=0;
//	console.log($('.'+froupIndex).find('#'+obj));
	$('.'+froupIndex).find('#'+obj).wrap('<div class="colorpicker btn-wrapper"></div>');
	var datacolor=$('.'+froupIndex).find("#"+obj).data("colors");
	var arr=datacolor.split(",");
	var color=getcolor(colorMap,selectedColor,'value');
	var btnBorderColor=getcolor(colorMap,selectedColor,'borderValue');
	var btn='<button type="button" class="btn dropdown-toggle" data-toggle="dropdown" style="background: '+selectedColor+'; color: '+color+'; border-color: '+btnBorderColor+';"><span class="cp-title" style="display: none;"></span><i class="ic icon-caret-down"></i></button>';
	var lis='<ul class="dropdown-menu clearfix pull-right" style="width: 156px;">';
	for(var i=0;i<arr.length;i++){
		var sRgbColor = arr[i].colorRgb();
		var borderColor=getcolor(colorMap,arr[i],'borderValue');
		if(arr[i]==selectedColor){
			lis+='<li style="width: 30px; height: 30px;"><a href="###" class="cp-tile active" data-color="'+arr[i]+'" style="color:'+colorMap[i].value+'; background: '+sRgbColor+'; border-color: '+borderColor+';"></a></li>'
			defaultIndex=i;
		}else {
			lis+='<li style="width: 30px; height: 30px;"><a href="###" class="cp-tile" data-color="'+arr[i]+'" style="color:'+colorMap[i].value+'; background: '+sRgbColor+'; border-color: '+borderColor+';"></a></li>'
		}	
	}
	lis+='<li style="width: 30px; height: 30px;"><a class="cp-tile empty" href="###"></a></ul>';
	$('.'+froupIndex).find("#"+obj).before(btn+lis);
//	$('#'+obj).prev().find("li").click(function(){
//		console.log("click");
//		$(this).parent().each(function(){
//			if($(this).find("a").hasClass("active")){
//				$(this).find("a").removeClass("active")
//			}
//		})
//		var checkedColor;
//		if($(this).find("a").hasClass("empty")){//点击取消其他颜色的选择
//			$(this).parent().find("li").eq(defaultIndex).find("a").addClass("active");
//			checkedColor=$(this).parent().find("li").eq(defaultIndex).find("a").attr("data-color");
//		}else {
//			$(this).find("a").addClass("active");
//			checkedColor=$(this).find("a").attr("data-color");	
//		}
//		var mapcolor=getcolor(colorMap,checkedColor,'value');
//		$(this).parent().next().val(checkedColor);
//		$(this).parent().prev().css({"background":checkedColor,'color':mapcolor});
//	})
}